cordova.define("pushe-cordova.pushe", function(require, exports, module) {
var exec = require("cordova/exec");
console.log("pushe plugin loaded.");
    var pushe = {};

    pushe.initialize = function() {
            console.log("Pushe.initialize started");
            cordova.exec(function(result){
                console.log("Execution succeeded", result);
             },
             function(result){
                 /*alert("Error" + reply);*/
             },"PusheCordova","initialize",[true]);
        
    };
    
    pushe.subscribe = function(topicName){
        console.log("Executing Pushe.subscribe ...");
        cordova.exec(function(result){
                     console.log("Execution succeeded", result);
                },
                function(result){
                     /*alert("Error" + reply);*/
                },"PusheCordova","subscribe",[topicName]);
    }

    pushe.unsubscribe = function(topicName){
        console.log("Executing Pushe.unsubscribe ...");
        cordova.exec(function(result){
                     console.log("Execution succeeded", result);
                 },
                 function(result){
                     /*alert("Error" + reply);*/
                 },"PusheCordova","unsubscribe",[topicName]);
    }

    pushe.setNotificationOff = function(){
        console.log("Executing Pushe.setNotificationOff ...");
        cordova.exec(function(result){
                 console.log("Execution succeeded", result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","setNotificationOff",[]);
    }

    pushe.setNotificationOn = function(){
        console.log("Executing Pushe.setNotificationOn ...");
        cordova.exec(function(result){
                 console.log("Execution succeeded", result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","setNotificationOn",[]);
    }

    pushe.isPusheInitialized = function(pusheInited){
        console.log("Executing Pushe.isPusheInitialized ...");
        cordova.exec(function(result){
                     console.log("Pushe.isPusheInitialized Execution succeeded", result);
                     pusheInited(result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","isPusheInitialized",[]);
    }

    pushe.getPusheId = function(pidCallback){
        console.log("Executing Pushe.getPusheId ...");
        cordova.exec(function(result){
                     console.log("Pushe.getPusheId Execution succeeded", result);
                     pidCallback(result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","getPusheId",[]);
    }


    pushe.sendSimpleNotifToUser = function(userPusheId, title, content){
        console.log("Executing Pushe.sendSimpleNotifToUser ...");
        cordova.exec(function(result){
                 console.log("Execution succeeded", result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","sendSimpleNotifToUser",[userPusheId, title, content]);
    }

    pushe.sendAdvancedNotifToUser = function(userPusheId, notificationJson){
        console.log("Executing Pushe.sendAdvancedNotifToUser ...");
        cordova.exec(function(result){
                 console.log("Execution succeeded", result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","sendAdvancedNotifToUser",[userPusheId, notificationJson]);
    }

    pushe.sendCustomJsonToUser = function(userPusheId, customJson){
        console.log("Executing Pushe.sendCustomJsonToUser ...");
        cordova.exec(function(result){
                 console.log("Execution succeeded", result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","sendCustomJsonToUser",[userPusheId, customJson]);
    }

    pushe.createNotificationChannel = function(channelId, channelName,
              description, importance, enableLight,
              enableVibration, showBadge, ledColor){
              console.log("Executing Pushe.sendCustomJsonToUser ...");
              cordova.exec(function(result){
                   console.log("Execution succeeded", result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                     },"PusheCordova","createNotificationChannel",[channelId, channelName,
                        description, importance, enableLight, enableVibration, showBadge, ledColor]);
    }

    pushe.removeNotificationChannel = function(channelId){
        console.log("Executing Pushe.sendCustomJsonToUser ...");
        cordova.exec(function(result){
                 console.log("Execution succeeded", result);
                 },
                 function(result){
                 /*alert("Error" + reply);*/
                 },"PusheCordova","removeNotificationChannel",[channelId]);
    }

    pushe.jsonCallback = function(callbackToUser){
        console.log("Setting Json Callback");
        cordova.exec(function(jsonMsg){
                    console.log("JsonReceiver callback has been fired." + JSON.stringify(jsonMsg));
                    callbackToUser(jsonMsg);
                 },
                 function(result){
                     /*alert("Error" + reply);*/
                 },"PusheCordova","jsonCallback",[]);
    }

module.exports = pushe;

});
